//#define ASM
#include "fat.h"
#include "standalone.h"

	.import _fragments,_FragmentList,_gFileNum,_HandleDir


// auto u_int16 OpenFile(register __c0 u_int16 fileNum) {
//     register __i1 __y struct FRAGMENT *curFragment = &fragments[0];
//     register __i0 __y struct FRAGMENT * __y nextFragment;

	.sect code,OpenFile	// 51 words -> 36
	.export _OpenFile
_OpenFile:	// PROLOGUE
	// stack increased in the caller
	stx A1,(I6)+1 ; sty B0,(I6)
	stx LR0,(I6)+1 ; sty I0,(I6)	// return address
	//ldc 512,MR0	// mode does not matter in this function..
	stx B1,(I6)+1 ; sty I2,(I6)

	// register parameter to function: C0
	// allocated I1 as curFragment
	// allocated I0 as nextFragment

//     if (fatInfo.IS_FAT_32)

	ldc _fatInfo,I2
#ifdef FATINFO_IN_Y
	ldy (I2)+(ROOTSTART-ISFAT32),A0 //ISFAT32
#else
	ldx (I2)+(ROOTSTART-ISFAT32),A0 //ISFAT32
#endif
	add A0,NULL,A0	; sty I1,(I6)+1
	ldc _fragments,I1
	jzs L2
	ldc 0x8000,B1

	ldc lo(2),B0
	and NULL,NULL,B1	; mv I1,I2
//  {
// 	nextFragment = FragmentList(curFragment, 2);

	// Register parameter: I2, pass by value
	// Register parameter: B, pass by value
	call _FragmentList
	ldc LE1,lr0
L2:

//     } else {
// 	curFragment->start = fatInfo.rootStart | 0x80000000UL ;
// 	curFragment->size  = (fatInfo.BPB_RootEntCnt >> 4);
// 	nextFragment = curFragment + 1;

#ifdef FATINFO_IN_Y
	ldy (I2)+1,A0	; ldx (i6)-1,null	//ROOTSTART
	ldy (I2)+(BPBROOTENTCNT-ROOTSTART-1-2),A1
	or A1,B1,A1	; ldx (I2)+2,NULL
	ldy (I2),B0	//BPBROOTENTCNT
#else
	ldx (I2)+1,A0	; ldy (i6)-1,null	//ROOTSTART
	ldx (I2)+(BPBROOTENTCNT-ROOTSTART-1-2),A1
	or A1,B1,A1	; ldx (I2)+2,NULL
	ldx (I2),B0	//BPBROOTENTCNT
#endif
	lsr B0,B0	; sty A0,(I1)+1
	and A1,NULL,A1	; sty A1,(I1)-1
	lsr B0,B0	; mv I1,I0
	lsr B0,B0	; ldx (I0)+3,NULL
	lsr B0,B0	; sty A1,(I0)-1	//+3 <= 0
	sty B0,(I0)+2	//+2
	//nextFragment: leave I0 at +4 -> A0
	mv I0,A0
LE1:

//     }
//     gFileNum[0] = fileNum;
//     gFileNum[1] = 0;

//     return HandleDir(curFragment, nextFragment);

	// Register parameter: I2, pass by value
	ldc _gFileNum+0,I5
	mv I1,I2
	and NULL,NULL,B0	; stx C0,(I5)+1
	stx B0,(I5)
	call _HandleDir	// parameter A0 in X, i1 saved in Y
	stx A0,(I6)+1	//nextFragment in A0

#if 1 //def SCI_UI
	ldc 0xc00f,i0	//SCI_AICTRL3,i0
	ldc ~(CTRL3_BY_NAME|CTRL3_ITERATE),B1
        ldx (i0),B0		; ldy (I6)-1,I1	// parameter in X..
	and B0,B1,B0		; ldx (I6),B1
	stx B0,(i0)		; ldy (I6)-1,I2
#else
	ldy (I6)-1,I1	// parameter in X..
	ldx (I6)-1,B1 ; ldy (I6),I2
#endif
	ldx (I6)-1,LR0 ; ldy (I6),I0
	jr
	ldx (I6)-1,A1 ; ldy (I6),B0


	// FUNCTION OpenFile(): stack usage ~ 2 x (9 + 1) = 2 x 10 words

	.end
