//#define ASM
//#define STANDALONE
#include <vs1053.h>

	.sect data_x,abs_x
	.org STACK_START
	.import __stack
//	.export __stack
//__stack:
	.bss STACK_SIZE

	.sect data_y,abs_y
	.org STACK_START
	.bss STACK_SIZE

	.sect code,start
	.org 0x50
	.import _MyMain
	.export _vs3emubreak
_vs3emubreak:// dummy label for VSIDE/vs3emu
$0:	call _MyMain
	ldc __stack,i6
	jmpi $0


#define SPI_xCS   1 /* GPIO */
#define SPI_CLK   8
#define SPI_MISO  4
#define SPI_MISO_SHIFT -3
#define SPI_xCS2  2
#define SPI_MOSI  1 /* DREQ */

	.sect code,SpiSendClocks
	.export _SpiSendClocks
_SpiSendClocks:
// auto void SpiSendClocks(void);
	stx ls,(i6)+1	; sty le,(i6)

	ldc 1,i5
	ldc SER_DREQ,i7
	stx i5,(i7)+(GPIO_ODATA-SER_DREQ) ; sty lc,(i6)	// data out (=1)
	ldc 16-1,ls
	loop ls,$0-1
	nop

	nop
	nop
	nop
	ldc SPI_CLK|SPI_xCS|SPI_xCS2,i5
	stx i5,(i7)	// clk up

	nop
	nop
	nop
	ldc SPI_xCS|SPI_xCS2,i5
	stx i5,(i7)	// clk down
	nop	//VS1003 seems to require this
$0:
	ldy (i6)-1,lc
	ldx (i6)-1,ls	; ldy (i6),le
	jr
	nop


	.end
